*********************************
***     ***
*********************************
Procedure LogEntry
Lparameters tuKeyValue

&&     ,    
&& Return .T.

If Empty(Set("Database"))
	&& Set DataBase to ( CursorGetProp("Database") )
	Wait Window "    !" + Chr(13) + "   ." Nowait
	Return .T.
EndIf

Local lcEditType, lcTableName, lnCounter, lcCorrections, lcField, luOldVal, luNewVal, lcCaption,lcUser, lcPrimaryKey, lcWorkStation

&&   
DO Case
Case GetFldState(0) = 3
	lcEditType = "APPEND"

Case Deleted() = .T.
	lcEditType = "DELETE"

Case GetFldState(0) = 2 && AND NOT Deleted()    ;)
	lcEditType = "RECALL"

Otherwise
	lcEditType = "UPDATE"

EndCase

lcTableName = CursorGetProp("SourceName") &&      ,  Alias()  

***      lcCorrections
lcCorrections = ""

If lcEditType = "UPDATE"

	For lnCounter = 1 to Fcount()

			lcField = Field(lnCounter)	&&  

			If InList( Type(lcField), "M", "G") &&   Memo  General
				Loop
			EndIf
	
			luOldVal = OldVal(lcField)	&&  
			luNewVal = Evaluate(lcField)&&  
			
			If luOldVal # luNewVal &&    

				#If Version(5) => 800	&&   VFP
				lcCaption = Field(lcField, Alias(), 1) && .   VFP 8

				#Else	&&   VFP 6,7
				lcCaption = DBGetProp(lcTableName + "." + lcField, "FIELD", "Caption")
				lcCaption = Iif(Empty(lcCaption), lcField, lcCaption) &&  Caption  ,     

				#EndIf

				&&  ,    

				lcCorrections = lcCorrections + ;
				PadC(lcCaption, 30, "_") + Chr(13) + ;
				"<- " + Rtrim(Transform(luOldVal)) + Chr(13) + ;
				"-> " + Rtrim(Transform(luNewVal)) + Chr(13) + Chr(13)

			EndIf
	EndFor
	
EndIf

&& ,     
If Parameters() < 1
	&&   ,   
	lcPrimaryKey = DBGetProp(lcTableName,"TABLE","PrimaryKey")
	
	If Empty(lcPrimaryKey)
		Wait Window "   ." + Chr(13) + "  ." Nowait
		Return .T.
	Else
		tuKeyValue = Evaluate(Key(TagNo(lcPrimaryKey)))
	
	EndIf
	
EndIf

lcUser = "" &&    ID     
lcWorkStation = Sys(0)

***     
Insert Into Changes_Log (TableName, KeyValue, Correction, Author, WrkStat, EditType, EditTime ) ;
Values (lcTableName, tuKeyValue, lcCorrections, lcUser, lcWorkStation, lcEditType, DateTime() )

Return .T.